/*
  Project GAD
  Author: Dana Vrajitoru
  List class definition
*/

#ifndef List_h
#define List_h

#include "ListNode.h"

class List {
  public:
  ListNode *head;
  ListNode *tail;
  int nodeNr;

  // Constructors
  List();
  List(List *data);

  // Init functions corresponding to each constructor
  void Init();
  void Init(List *data);
  
  // Desctructor
  ~List();

  // List manipulation
  void AddHead(int val, float cost=0.0);
  void AddTail(int val, float cost=0.0);
  int RemoveHead();
  int RemoveTail();

  // Some useful methods
  int IsEmpty();
  int Find(int val);
  ListNode *FindNode(int val);

  // Output
  void Print();
  void FPrint(FILE *aFile);
};

#endif
