/*
  Project GAD
  Author: Dana Vrajitoru
  ListNode class definition
*/

#ifndef ListNode_h
#define ListNode_h

#include <stdio.h>

class ListNode {
  public:
  int elem;
  float weight;
  ListNode *next, *pred;

  // Constructors
  ListNode(int val=0, float cost=0.0);
  ListNode(ListNode *data);

  // Destructor
  ~ListNode();

  // Init corresponding to each constructor
  void Init(int val=0, float cost=0.0);
  void Init(ListNode *data);

  // List operations
  void AddHead(ListNode *node);
  void AddTail(ListNode *node);
  ListNode *RemoveHead();
  ListNode *RemoveTail();

  // Output
  void Print();
  void FPrint(FILE *aFile);
};

#endif
